/******************************************************************************
 *
 * bung 13  Martin Hess, MC2, 21.9.2001
 *
 ******************************************************************************
 */

#include "CB_TSU2.h"

#define Schalter (*(volatile unsigned char*)(0x400030))

void init(void); // Initialisiert Programm
unsigned char Set_X(unsigned char x); // Setzt X auf angegebene Position
void Disp_Score(unsigned int x); // Zeigt Score an 
char Move(char pos, unsigned int* sco_ptr); //Bewegt Zeiger und stoppt. 1= getroffen, 0= nicht getroffen  
void Disp_I(unsigned char x); // Zeigt I an Position x an   
void wait(int count); // Warteschlaufe
void clear_row(char row); //Lscht angegebene Zeile

int main (void)
{ 
unsigned int score;
char Hit; 
unsigned char pos;  
unsigned int * sco_ptr;

init();
score = 0; 
pos = 1;              
sco_ptr = &score;
do  
	{    
	pos = Set_X(pos);
	Hit = Move(pos,sco_ptr);
	if (Hit == 1) score = score + 5; 
	Disp_Score(score); 
	}
while(1);
} // of main  

void init(void)
{
LCD_IWrite(0x01); //lscht LCD  
clear_row(2);
clear_row(3);
CBTSU_DispString(1,"Uebung 13 Catch it"); 
Disp_Score(0);
} // of init 

unsigned char Set_X(unsigned char x) 
{
unsigned char new_pos;

clear_row(2);
x = x * 7;
new_pos = x % 20; //Modulo 20
LCD_XY(new_pos,2);
LCD_Char('X');
return(new_pos);
} // of Set_x 

void Disp_Score(unsigned int x)
{ 

CBTSU_DispString(4,"Score:");
if (x < 10)
	{
	LCD_Char(x+'0');
	}
else
	{
	LCD_Char((x/10)+'0');
	LCD_Char((x%10)+'0');
	}
} // of Disp_Score  

char Move(char pos, unsigned int* sco_ptr)
{
unsigned char Hit;
unsigned char x;

Hit = 0; 
do
	{
	for (x=1; x<=20; x++)
		{ 
		Disp_I(x);
		wait((800-((*sco_ptr) * 10))); 
		if ((Schalter & 0x80) != 0) // wenn Schalter bettigt...
			{
			if (x == pos) // ...und Treffer:
				{
				x = 20;
				Hit = 1; 
				CBTSU_DispString(3,"** HIT !!! **");
				do 
					wait(100);
				while ((Schalter & 0x80) != 0);  
				clear_row(3);
				}
			else          // ... und kein Treffer
				{                                      
				CBTSU_DispString(3,"missed...");   
				if (*sco_ptr > 0) *sco_ptr = *sco_ptr - 1;
				Disp_Score(*(sco_ptr));
				do 
					wait(100);
				while ((Schalter & 0x80) != 0);  
				clear_row(3);
	     	 }; // of if
			}; // of if
		}; // of for
	} while (Hit == 0);
return(Hit);
} // of Move   

void Disp_I(unsigned char x)
{
if (x > 1) 
	{    
	LCD_XY((x-1),3);
	}
 else LCD_XY(20,3);
LCD_Char(' ');
LCD_XY(x,3);
LCD_Char('I');
} // of Disp_I    


void wait(int count)
{
int i;  
int j; 
for (i=0; i<count; i++)
	{                   
	for (j=0; j<count; j++);
	};	
} // of wait          

void clear_row(char row)
{                
char i;
       
for (i=1; i<=20; i++)
	{ 
	LCD_XY(i,row);
	LCD_Char(' ');
	};
} // of clear_row
                   